/*
WIFI-SCAN 
Version 1.00

Les détails sont disponibles sur / Details are available here:
  https://f1atb.fr  Section Domotique / Home Automation

  F1ATB Juillet / July  2024 

  GNU Affero General Public License (AGPL) / AGPL-3.0-or-later

*/


//WIFI
#include <WiFi.h>
#include <WebServer.h>
#include "pageHtmlWifi.h"
//WIFI

const char *ap_default_ssid;        // Mode Access point  IP: 192.168.4.1
const char *ap_default_psk = NULL;  // Pas de mot de passe en AP,
String Liste_AP;
String GS = String((char)29);  //Group Separator
String RS = String((char)30);  //Record Separator

unsigned long previousScan;
WebServer server(80);  // Simple Web Server on port 80
void setup() {
  ap_default_ssid = "Wifi-Scan";
  Serial.begin(115200);
  Serial.println("Booting");
  WiFi.mode(WIFI_AP);
  WiFi.softAP(ap_default_ssid, ap_default_psk);
  Serial.print("Access Point Mode. IP address: ");
  Serial.println(WiFi.softAPIP());
  previousScan = millis();
  server.on("/", handleRoot);
  server.on("/AP_ScanWifi", handleAP_ScanWifi);
  server.begin();
}

void loop() {
  if (millis() - previousScan >= 2000) {
    Liste_WIFI();
    previousScan = millis();
  }
  delay(10);
  server.handleClient();
}
void Liste_WIFI() {  //Doit être fait avant toute connection WIFI depuis biblio ESP32 3.0.1

  int n = 0;
  WiFi.disconnect();
  Serial.println("Scan start");
  // WiFi.scanNetworks will return the number of networks found.
  n = WiFi.scanNetworks();
  Serial.println("Scan done");
  Liste_AP = "";
  if (n == 0) {
    Serial.println("Pas de réseau Wifi trouvé");
  } else {
    Serial.print(n);
    Serial.println(" réseaux trouvés");
    Serial.println("Nr | SSID                             | RSSI ");
    for (int i = 0; i < n; ++i) {
      // Print SSID and RSSI for each network found
      Serial.printf("%2d", i + 1);
      Serial.print(" | ");
      Serial.printf("%-32.32s", WiFi.SSID(i).c_str());
      Serial.print(" | ");
      Serial.printf("%4d", WiFi.RSSI(i));
      Serial.println();
      String Enc = "";
      switch (WiFi.encryptionType(i)) {
        case WIFI_AUTH_OPEN: Enc = "open"; break;
        case WIFI_AUTH_WEP: Enc = "WEP"; break;
        case WIFI_AUTH_WPA_PSK: Enc = "WPA"; break;
        case WIFI_AUTH_WPA2_PSK: Enc = "WPA2"; break;
        case WIFI_AUTH_WPA_WPA2_PSK: Enc = "WPA+WPA2"; break;
        case WIFI_AUTH_WPA2_ENTERPRISE: Enc = "WPA2-EAP"; break;
        case WIFI_AUTH_WPA3_PSK: Enc = "WPA3"; break;
        case WIFI_AUTH_WPA2_WPA3_PSK: Enc = "WPA2+WPA3"; break;
        case WIFI_AUTH_WAPI_PSK: Enc = "WAPI"; break;
        default: Enc = "unknown";
      }

      Liste_AP += String(WiFi.SSID(i)) + RS + String(WiFi.RSSI(i)) + RS + String(WiFi.channel(i)) + RS + Enc + GS;
    }
  }
  WiFi.scanDelete();
}
void handleRoot() {
  server.sendHeader("Connection", "close");
  server.send(200, "text/html", String(ConnectAP_Html));
}
void handleAP_ScanWifi() {
  server.sendHeader("Connection", "close");
  server.send(200, "text/html", Liste_AP);
}